package javax.lang.model.element;

import java.util.List;
import javax.lang.model.type.TypeMirror;

public interface AnnotationValueVisitor<R, P>
{
    public abstract R visit(AnnotationValue p0, P p1);
    
    public abstract R visit(AnnotationValue p0);
    
    public abstract R visitBoolean(boolean p0, P p1);
    
    public abstract R visitByte(byte p0, P p1);
    
    public abstract R visitChar(char p0, P p1);
    
    public abstract R visitDouble(double p0, P p1);
    
    public abstract R visitFloat(float p0, P p1);
    
    public abstract R visitInt(int p0, P p1);
    
    public abstract R visitLong(long p0, P p1);
    
    public abstract R visitShort(short p0, P p1);
    
    public abstract R visitString(String p0, P p1);
    
    public abstract R visitType(TypeMirror p0, P p1);
    
    public abstract R visitEnumConstant(VariableElement p0, P p1);
    
    public abstract R visitAnnotation(AnnotationMirror p0, P p1);
    
    public abstract R visitArray(List<? extends AnnotationValue> p0, P p1);
    
    public abstract R visitUnknown(AnnotationValue p0, P p1);
}
